<component-section>
  <div slot="title">🔃 Recursie en algoritmeontwerp</div>
  <component-section>
    <div slot="title">Waarom je over recursie en algoritmeontwerp leert</div>
    <p>
      Recursie is voor algoritmes vaak erg belangrijk. Recursie zorgt ervoor dat functies beknopt kunnen worden
      opgeschreven, en dat je over het probleem dat een algoritme moet oplossen makkelijker kan nadenken.
    </p>
    <p>
      Algoritmeontwerpparadigma’s geven je inzicht in algemene manieren om een algoritme te ontwikkelen en te begrijpen.
      Dat is een belangrijke vaardigheid zodra je uiteindelijk de standaardalgoritmes wel paraat hebt, maar
      geconfronteerd kan worden met nieuwe.
    </p>
  </component-section>
  <component-section>
    <div slot="title">Recursie</div>
    <p>Recursie houdt in dat een functie pas zijn waarde krijgt door zichzelf weer aan te roepen.</p>
    <p class="bron">
      <a href="http://jeffe.cs.illinois.edu/teaching/algorithms/book/01-recursion.pdf">Recursion</a>
      <cite data-id="6867189/PLHZEH2X" data-label="section" data-locator="1.1-1.3"></cite>
    </p>
    <p><em class="term">Recursie</em> zie je terug in broncode als een aanroep van een functie naar zichzelf.</p>
    <p>
      Wat je met recursie kan doen kan je ook met een lus doen. Zie bijvoorbeeld de implementatie van
      <a href="https://rosettacode.org/wiki/Binary_search">binary search</a>.
    </p>
    <ol>
      <li>
        <p><em class="term">Basisgeval</em> (base case): hier eindigt de recursie.</p>
      </li>
      <li>
        <p><em class="term">Recursief geval</em> (recursive case)</p>
      </li>
    </ol>
    <p>
      Welk van bovenstaande gevallen van toepassing is, ligt aan de conditionele structuur (bijvoorbeeld
      <code class="lang-java">if () {} else {}</code>). Een recursie is <em class="term">eindig</em> als het basisgeval
      werkelijk bereikt kan worden (dat wil zeggen, de conditie daarvoor kan waar worden).
    </p>
    <!-- TODO: Stellingen over vertaling algoritme-implementaties van recursief <-> iteratief. -->
    <p>
      Een de looptijdfunctie van een recursief algoritme kan je wiskundig beschrijven met een
      <em class="term">recurrente betrekking</em> (<em class="term">recurrence</em>). De looptijdfunctie zo opschrijven
      is intuïtief. Een ander voordeel is dat je enkele standaard wiskundige procedures kan toepassen om
      algoritmeanalyse te doen op basis van de looptijdfunctie, in plaats van de (ingewikkelde) recursieve broncode te
      moeten analyseren. Zulke wiskundige algoritmeanalyse doen valt buiten de leerinhoud van ADP. Maar het is wel
      handig om te leren om een recursieve formule als een recurrente betrekking op te schrijven.
    </p>
    <p>Ook algoritmes zelf kan je soms met een recurrente betrekking beschrijven. Zie het volgende voorbeeld:</p>
    <figure>
      <figcaption>Recurrente betrekking voor vermenigvuldigen.</figcaption>
      <!-- prettier-ignore -->
      <p>$$x·y = \begin{cases}
0                                     &amp; \text{als } x = 0 \\
\lfloor x/2 \rfloor · (y + y)       &amp; \text{als } x \text{ even is} \\
\lfloor x/2 \rfloor · (y + y) + y   &amp; \text{als } x \text{ oneven is} \\
\end{cases}$$</p>
    </figure>
    <p>In het voorgaande voorbeeld is vermenigvuldigen (althans, de operator \(·\)) recursief gedefinieerd.</p>
    <ul>
      <li>
        <p>
          De betrekking is te lezen als een
          <code class="lang-java">if () {} else if {}</code>-achtige conditionele structuur. De conditie staat aan de
          rechterkant, het conditionele blok aan de linkerkant.
        </p>
      </li>
      <li>
        <p>
          In de twee gevallen anders dan het basisgeval \(x = 0\) is \(x·y\) gedefinieerd als een recursieve
          uitdrukking. Die twee uitdrukkingen verwijzen namelijk weer naar zichzelf, door de \(·\) die er opnieuw in
          staat.
        </p>
      </li>
      <li>
        <p>
          \(\lfloor d \rfloor\) betekent: alle cijfers achter de komma van \(d\) weggooien, om zo alleen het gehele
          getal voor de komma te behouden. (Tussen deze haakjes mag in plaats van \(d\) iedere uitdrukking met een
          rationaal getal als waarde staan.)
        </p>
      </li>
    </ul>
    <component-section>
      <div slot="title">
        <a href="https://ans.app/digital_test/assignments/297664/routing">Recurrente betrekking (op Ans)</a>
      </div>
      <component-exercise></component-exercise>
    </component-section>
  </component-section>
  <component-section>
    <div slot="title">Algoritmeontwerp</div>
    <p>
      Een algoritme kan <em class="term">incrementeel</em> te werk gaan. Het werkt dan op één positie binnen een
      data(structuur). Denk aan een index in een rij.
    </p>
    <p>
      Het eenvoudigste algoritmeontwerppatroon is
      <em class="term">brute force</em> (dommekracht). Brute force betekent dat een algoritme alle mogelijke paden naar
      een oplossing van een probleem berekent, ongeacht of het onnodig (bijvoorbeeld dubbel) werk aan het doen is.
    </p>
    <p>
      Een alternatief hiervoor is het verdelen van het probleem, en op meerdere posities tegelijk werken. Het probleem
      kan dan verdeeld worden over meerdere processors en daardoor sneller worden opgelost. Een ander voordeel is dat
      het algoritme eenvoudiger kan worden, zoals bij recursie. Tot slot zou een voordeel kunnen zijn dat een
      deeloplossing van het probleem het mogelijk maakt een deel van de rest van het probleem links te laten liggen.
    </p>
    <component-section>
      <div slot="title">Divide-and-conquer</div>
      <p>
        Veel problemen hebben
        <em class="term">optimale substructuur</em>: om het hele probleem op te lossen, komt erop neer dat je (steeds)
        kleinere deelproblemen oplost. Je lost het probleem op door de deeloplossingen te combineren. Merge sort is hier
        een voorbeeld van.
      </p>
      <p>
        De drie stappen van
        <em class="term">divide-and-conquer</em> (verdeel en heers) zijn:
      </p>
      <ol>
        <li>
          <p><em>Divide</em>: opdelen probleem in delen van een datastructuur.</p>
        </li>
        <li>
          <p><em>Conquer</em>: verder opdelen, óf als deelprobleem inderdaad klein genoeg is, oplossen.</p>
        </li>
        <li>
          <p><em>Combine</em>: combineren van de oplossingen voor de deelproblemen.</p>
        </li>
      </ol>
      <p>
        Hoe klein een deelprobleem wordt hangt af van het algoritme zelf. Het kan bijvoorbeeld \(\frac{1}{b}\)<sup
          >e</sup
        >
        deel zijn, waarbij \(b\) bijvoorbeeld \(2\) is (dat is zo bij Merge sort).
      </p>
      <p>
        Misschien had je het al door: als je steeds kleinere subproblemen aan het oplossen bent, dan is recursie een
        natuurlijke vorm om het algoritme te ontwerpen.
      </p>
      <!-- TODO: -->
      <!--
            <p class="bron">
                <cite data-id="6867189/GMIDVX6P" data-label="section" data-locator="2.3"></cite>
                <cite data-id="6867189/GMIDVX6P" data-label="chapter" data-locator="4"></cite>
                <cite data-id="6867189/GMIDVX6P" data-label="section" data-locator="4-4.5"></cite>
                (Divide-and-Conquer)
            </p>
          -->
    </component-section>
    <component-section>
      <div slot="title">Dynamic programming</div>
      <p>
        <em class="term">Dynamic programming</em> is een andere manier om deeloplossingen te gebruiken dan
        divide-and-conquer. Dynamic programming wordt gebruikt als een probleem alleen op te delen is in
        <em>overlappende</em> deelproblemen, terwijl divide-and-conquer het probleem in gescheiden deelproblemen oplost.
        Dynamic programming wordt vaak gebruikt bij algoritmes die <em>optimalisatieproblemen</em> oplossen. Er zijn dan
        meerdere oplossingen correct. De oplossingen hebben een bepaalde waarde, en de <em>beste</em> oplossing heeft de
        laagste dan wel hoogste waarde. Dan zou je dynamic programming als volgt kunnen definiëren:
      </p>
      <ol>
        <li>
          <p>Stel de structuur vast van de optimale oplossing.</p>
        </li>
        <li>
          <p>Definieer de waarde van de optimale oplossing recursief.</p>
        </li>
        <li>
          <p>Bereken een steeds optimalere oplossing bottom-up.</p>
        </li>
        <li>
          <p>Structureer de optimale oplossing.</p>
        </li>
      </ol>
      <p>
        ‘Dynamic’ staat voor de notie dat het algoritme slim bepaalt welk deelprobleem het telkens gaat oplossen. Heel
        wat slimmer dan brute force, tenminste!
      </p>
      <p>
        Ook bij sommige andersoortige algoritmes, zoals bijvoorbeeld de Rij van Fibonacci berekenen, zijn er meerdere
        stadia waarin het algoritme hetzelfde deelprobleem tegenkomt. Dan is het efficiënter om het deelprobleem niet
        meermaals op te gaan lossen, en dat kan met dynamic programming.
      </p>
      <p>
        Het bewaren van deeloplossingen heet
        <em class="term">memoisatie</em> (memoization). Door deeloplossingen te bewaren, wissel je looptijd in voor
        geheugenruimte.
      </p>
      <p>
        In de volgende bron legt Gayle Laakmann McDowell uit hoe dynamic programming met memoïsatie er concreet uitziet,
        met een algoritme om de rij van Fibonacci te berekenen.
      </p>
      <p class="bron">Algorithms: Memoization and Dynamic Programming</p>
      <component-video videoid="P8Xa2BitN3I" title="Algorithms: Memoization and Dynamic Programming"></component-video>
      <!-- TODO: -->
      <!--
            <p class="bron">
              <cite data-id="6867189/GMIDVX6P" data-label="page" data-locator="357-385"></cite>
              <cite data-id="6867189/GMIDVX6P" data-label="chapter" data-locator="15-15.1" data-suffix="incl. inleiding"></cite>
              <cite data-id="6867189/GMIDVX6P" data-label="section" data-locator="15.3"></cite>
              (Dynamic Programming)
          </p>
        -->
    </component-section>
    <component-section>
      <div slot="title">Greediness</div>
      <p>
        Soms is het makkelijker om snel een oplossing te geven op basis van een deel van de invoerdata. Welk
        deelprobleem het algoritme oplost (de volgorde daarvan) beïnvloedt dan wel oplossing waarop het algoritme
        uitkomt voor het hele probleem. Toch kan het algoritme voor de optimale oplossing voor het deelprobleem gaan, in
        de verwachting dat dit ook leidt tot een optimale oplossing voor het hele probleem. Dit heet
        <em class="term">greediness</em> (gulzigheid).
      </p>
      <p>
        Een voorbeeld hiervan is het algoritme: geef het minimale aantal munten dat je nodig hebt als wisselgeld. We
        kunnen de munt die het meeste waard is kiezen die niet groter is dan het verschil dat overblijft. Voor dit soort
        problemen komt een greedy algoritme sneller op de optimale oplossing dan een dynamic programming-algoritme.
      </p>
      <!-- TODO: -->
      <!--
        <p class="bron">
          <cite data-id="6867189/GMIDVX6P"></cite>
          <cite data-id="6867189/GMIDVX6P" data-label="section" data-locator="16-16.2"></cite>
          (Greedy Algorithms)
      </p>
    -->
    </component-section>
  </component-section>
</component-section>
